--- asterisk-1.2.11/channels/chan_zap.dist.c	2006-08-07 03:28:29.000000000 +0200
+++ asterisk-1.2.11/channels/chan_zap.c	2006-08-23 18:17:22.107642992 +0200
@@ -223,6 +223,8 @@
 static int immediate = 0;
 
 static int stripmsd = 0;
+static int stripnationalprefix = 1;
+static int stripinternationalprefix = 1;
 
 static int callwaiting = 0;
 
@@ -599,6 +601,8 @@
 	unsigned int r2blocked:1;
 	unsigned int sigchecked:1;
 #endif
+	unsigned int stripnationalprefix:1;
+	unsigned int stripinternationalprefix:1;
 
 	struct zt_distRings drings;
 
@@ -2093,10 +2097,14 @@
  		pridialplan = p->pri->dialplan - 1;
  		if (pridialplan == -2) { /* compute dynamically */
  			if (strncmp(c + p->stripmsd, p->pri->internationalprefix, strlen(p->pri->internationalprefix)) == 0) {
- 				dp_strip = strlen(p->pri->internationalprefix);
+				if (p->stripinternationalprefix) {
+ 					dp_strip = strlen(p->pri->internationalprefix);
+				}
  				pridialplan = PRI_INTERNATIONAL_ISDN;
  			} else if (strncmp(c + p->stripmsd, p->pri->nationalprefix, strlen(p->pri->nationalprefix)) == 0) {
- 				dp_strip = strlen(p->pri->nationalprefix);
+				if (p->stripnationalprefix) {
+ 					dp_strip = strlen(p->pri->nationalprefix);
+				}
  				pridialplan = PRI_NATIONAL_ISDN;
  			} else {
 				pridialplan = PRI_LOCAL_ISDN;
@@ -2108,10 +2116,14 @@
 		prilocaldialplan = p->pri->localdialplan - 1;
 		if ((l != NULL) && (prilocaldialplan == -2)) { /* compute dynamically */
 			if (strncmp(l, p->pri->internationalprefix, strlen(p->pri->internationalprefix)) == 0) {
-				ldp_strip = strlen(p->pri->internationalprefix);
+				if (p->stripinternationalprefix) {
+					ldp_strip = strlen(p->pri->internationalprefix);
+				}
 				prilocaldialplan = PRI_INTERNATIONAL_ISDN;
 			} else if (strncmp(l, p->pri->nationalprefix, strlen(p->pri->nationalprefix)) == 0) {
-				ldp_strip = strlen(p->pri->nationalprefix);
+				if (p->stripnationalprefix) {
+					ldp_strip = strlen(p->pri->nationalprefix);
+				}
 				prilocaldialplan = PRI_NATIONAL_ISDN;
 			} else {
 				prilocaldialplan = PRI_LOCAL_ISDN;
@@ -7149,6 +7161,8 @@
 		tmp->hidecallerid = tmp->permhidecallerid;
 		tmp->channel = channel;
 		tmp->stripmsd = stripmsd;
+		tmp->stripnationalprefix = stripnationalprefix;
+		tmp->stripinternationalprefix = stripinternationalprefix;
 		tmp->use_callerid = use_callerid;
 		tmp->cid_signalling = cid_signalling;
 		tmp->cid_start = cid_start;
@@ -10433,6 +10447,10 @@
 			ast_copy_string(musicclass, v->value, sizeof(musicclass));
 		} else if (!strcasecmp(v->name, "stripmsd")) {
 			stripmsd = atoi(v->value);
+                } else if (!strcasecmp(v->name, "stripnationalprefix")) {
+			stripnationalprefix = ast_true(v->value);
+		} else if (!strcasecmp(v->name, "stripinternationalprefix")) {
+			stripinternationalprefix = ast_true(v->value);
 		} else if (!strcasecmp(v->name, "jitterbuffers")) {
 			numbufs = atoi(v->value);
 		} else if (!strcasecmp(v->name, "group")) {
